using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;

namespace Transparent_layer
{
    public partial class Form1 : Form
    {
        Bitmap picture;
        public Form1()
        {
            InitializeComponent();
        }


        private void button1_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                pictureBox1.Image = fill_layer(pictureBox1, pictureBox2.Image, colorDialog1.Color, trackBar1.Value);
            }
        }

        private static Image fill_layer(PictureBox Pic_Box, Image img, Color Layer_color, int Percent)
        {
            Pic_Box.Image = img;
            Bitmap bmp_img = new Bitmap(Pic_Box.Image);
            Graphics ghp = Graphics.FromImage(bmp_img);
            LinearGradientBrush LineaBrush;
            LineaBrush = new LinearGradientBrush(new Rectangle(0, 0, bmp_img.Width, bmp_img.Height), Color.FromArgb(Percent, Layer_color), Color.FromArgb(Percent, Layer_color), LinearGradientMode.BackwardDiagonal);
            ghp.FillRectangle(LineaBrush, new Rectangle(0, 0, bmp_img.Width, bmp_img.Height));
            return (Image)bmp_img;
        }

        private void trackBar1_ValueChanged(object sender, EventArgs e)
        {
            toolTip1.SetToolTip(trackBar1, trackBar1.Value.ToString());
            pictureBox1.Image = fill_layer(pictureBox1, pictureBox2.Image, colorDialog1.Color, trackBar1.Value);
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {

        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {

        }

        private void btnload_Click(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "jpg file (*.jpg) |*.jpg|"
       + " All files (*.*) |*.*";
            openFileDialog1.FilterIndex = 1;
            openFileDialog1.Title = "load pic";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                picture = new Bitmap(openFileDialog1.FileName);
                pictureBox2.Image = picture;








            }
        }

        private void btnrgb2gray_Click(object sender, EventArgs e)
        {
            int i, j, r1, r2, r3, z;
            Color k;
            for (i = 0; i < picture.Width; i++)
                for (j = 0; j < picture.Height; j++)
                {
                    k = picture.GetPixel(i, j);
                    r1 = k.R;
                    r2 = k.G;
                    r3 = k.B;
                    z = (r1 + r2 + r3) / 3;
                    picture.SetPixel(i, j, Color.FromArgb(z, z, z));
                }
            pictureBox1.Image = picture;
        }

        private void btnmedian_Click(object sender, EventArgs e)
        {
            int i, j;
            int zr, zg, zb;
            Color c1, c2, c3, c4, c5, c6, c7, c8, c9;
            for (i = 2; i <= picture.Width - 2; i++)
                for (j = 2; j < picture.Height - 2; j++)
                {
                    c1 = picture.GetPixel(i - 1, j - 1);
                    c2 = picture.GetPixel(i, j - 1);
                    c3 = picture.GetPixel(i + 1, j - 1);
                    c4 = picture.GetPixel(i - 1, j);
                    c5 = picture.GetPixel(i, j);
                    c6 = picture.GetPixel(i + 1, j);
                    c7 = picture.GetPixel(i - 1, j + 1);
                    c8 = picture.GetPixel(i, j + 1);
                    c9 = picture.GetPixel(i + 1, j + 1);

                    zr = (c1.R / 9 + c2.R / 9 + c3.R / 9 + c4.R / 9 + c5.R / 9 + c6.R / 9 + c7.R / 9 + c8.R / 9 + c9.R / 9);
                    zg = (c1.G / 9 + c2.G / 9 + c3.G / 9 + c4.G / 9 + c5.G / 9 + c6.G / 9 + c7.G / 9 + c8.G / 9 + c9.G / 9);
                    zb = (c1.B / 9 + c2.B / 9 + c3.B / 9 + c4.B / 9 + c5.B / 9 + c6.B / 9 + c7.B / 9 + c8.B / 9 + c9.B / 9);

                    picture.SetPixel(i, j, Color.FromArgb(zr, zg, zb));

                }
            pictureBox1.Image = picture;
        }

        private void btngause_Click(object sender, EventArgs e)
        {
            int i, j;
            Color z1, z2, z3, z4, z5, z6, z7, z8, z9;
            int z5r, z5g, z5b;
            for (i = 2; i < picture.Width - 2; i++)
                for (j = 2; j < picture.Height - 2; j++)
                {
                    z1 = picture.GetPixel(i - 1, j - 1);
                    z2 = picture.GetPixel(i, j - 1);
                    z3 = picture.GetPixel(i + 1, j - 1);
                    z4 = picture.GetPixel(i - 1, j);
                    z5 = picture.GetPixel(i, j);
                    z6 = picture.GetPixel(i + 1, j);
                    z7 = picture.GetPixel(i - 1, j + 1);
                    z8 = picture.GetPixel(i, j + 1);
                    z9 = picture.GetPixel(i + 1, j + 1);

                    z5r = (z1.R + 2 * z2.R + z3.R + 2 * z4.R + 4 * z5.R + 2 * z6.R + z7.R + 2 * z8.R + z9.R) / 16;
                    z5g = (z1.G + 2 * z2.G + z3.G + 2 * z4.G + 4 * z5.G + 2 * z6.G + z7.G + 2 * z8.G + z9.G) / 16;
                    z5b = (z1.B + 2 * z2.B + z3.B + 2 * z4.B + 4 * z5.B + 2 * z6.B + z7.B + 2 * z8.B + z9.B) / 16;

                    picture.SetPixel(i, j, Color.FromArgb(z5r, z5g, z5b));
                    pictureBox1.Image = picture;
                }
        }

        private void btngrayetobw_Click(object sender, EventArgs e)
        {
            int i, j, r1, r2, r3, z, r;
            Color k;
            for (i = 0; i < picture.Width; i++)
                for (j = 0; j < picture.Height; j++)
                {
                    r = 127;

                    k = picture.GetPixel(i, j);
                    r1 = k.R;


                    r2 = k.G;
                    r3 = k.B;
                    z = (r1 + r2 + r3) / 3;
                    if (z < r)
                        z = 0;
                    else
                        z = 255;
                    picture.SetPixel(i, j, Color.FromArgb(z, z, z));

                }
            pictureBox1.Image = picture;
        }

        private void btnsave_Click(object sender, EventArgs e)
        {
            saveFileDialog1.ShowDialog();
            picture.Save(saveFileDialog1.FileName);
        }

        private void btnnegative_Click(object sender, EventArgs e)
        {
            int i, j, r1, r2, r3;
            Color k;
            for (i = 0; i < picture.Width; i++)
                for (j = 0; j < picture.Height; j++)
                {
                    k = picture.GetPixel(i, j);
                    r1 = 255 - k.R;
                    r2 = 255 - k.G;
                    r3 = 255 - k.B;

                    picture.SetPixel(i, j, Color.FromArgb(r1, r2, r3));
                }
            pictureBox1.Image = picture;
        }

        public void ShowAboutBox()
        {

            AboutBox1 objAbout = new AboutBox1();
            objAbout.ShowDialog(this);
        }
        private void btnabout_Click(object sender, EventArgs e)
        {
            ShowAboutBox();
        }

        private void btnmedian_Click_1(object sender, EventArgs e)
        {

            int i, j;


            Color c1, c2, c3, c4, c5, c6, c7, c8, c9;
            for (i = 2; i <= picture.Width - 2; i++)
                for (j = 2; j < picture.Height - 2; j++)
                {
                    c1 = picture.GetPixel(i - 1, j - 1);
                    c2 = picture.GetPixel(i, j - 1);
                    c3 = picture.GetPixel(i + 1, j - 1);
                    c4 = picture.GetPixel(i - 1, j);
                    c5 = picture.GetPixel(i, j);
                    c6 = picture.GetPixel(i + 1, j);
                    c7 = picture.GetPixel(i - 1, j + 1);
                    c8 = picture.GetPixel(i, j + 1);
                    c9 = picture.GetPixel(i + 1, j + 1);
                    int[] zr = new int[9] { c1.R, c2.R, c3.R, c4.R, c5.R, c6.R, c7.R, c8.R, c9.R };
                    int[] zg = new int[9] { c1.G, c2.G, c3.G, c4.G, c5.G, c6.G, c7.G, c8.G, c9.G };
                    int[] zb = new int[9] { c1.B, c2.B, c3.B, c4.B, c5.B, c6.B, c7.B, c8.B, c9.B };



                    Array.Sort(zr);
                    Array.Sort(zb);
                    Array.Sort(zg);




                    picture.SetPixel(i, j, Color.FromArgb(zr[5], zg[5], zb[5]));

                }
            pictureBox1.Image = picture;
        }

        private void openToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "jpg file (*.jpg) |*.jpg|"
       + " All files (*.*) |*.*";
            openFileDialog1.FilterIndex = 1;
            openFileDialog1.Title = "load pic";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                picture = new Bitmap(openFileDialog1.FileName);
                pictureBox2.Image = picture;
            }


        }

        private void exitToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AboutBox1 objAbout = new AboutBox1();
            objAbout.ShowDialog(this);
        }

        private void saveToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            saveFileDialog1.ShowDialog();
            picture.Save(saveFileDialog1.FileName);
        }

        private void printToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void undoToolStripMenuItem_Click(object sender, EventArgs e)
        {
        }

        private void customizeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            int i, j, r1, r2, r3, z;
            Color k;
            for (i = 0; i < picture.Width; i++)
                for (j = 0; j < picture.Height; j++)
                {
                    k = picture.GetPixel(i, j);
                    r1 = k.R;
                    r2 = k.G;
                    r3 = k.B;
                    z = (r1 + r2 + r3) / 3;
                    picture.SetPixel(i, j, Color.FromArgb(z, z, z));
                }
            pictureBox1.Image = picture;
        }

        private void optionsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            int i, j, r1, r2, r3, z, r;
            Color k;
            for (i = 0; i < picture.Width; i++)
                for (j = 0; j < picture.Height; j++)
                {
                    r = 127;

                    k = picture.GetPixel(i, j);
                    r1 = k.R;


                    r2 = k.G;
                    r3 = k.B;
                    z = (r1 + r2 + r3) / 3;
                    if (z < r)
                        z = 0;
                    else
                        z = 255;
                    picture.SetPixel(i, j, Color.FromArgb(z, z, z));
                }
        }

        private void negativeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            int i, j, r1, r2, r3;
            Color k;
            for (i = 0; i < picture.Width; i++)
                for (j = 0; j < picture.Height; j++)
                {
                    k = picture.GetPixel(i, j);
                    r1 = 255 - k.R;
                    r2 = 255 - k.G;
                    r3 = 255 - k.B;

                    picture.SetPixel(i, j, Color.FromArgb(r1, r2, r3));
                }
            pictureBox1.Image = picture;
        }

        private void midilingToolStripMenuItem_Click(object sender, EventArgs e)
        {
            int i, j;
            int zr, zg, zb;
            Color c1, c2, c3, c4, c5, c6, c7, c8, c9;
            for (i = 2; i <= picture.Width - 2; i++)
                for (j = 2; j < picture.Height - 2; j++)
                {
                    c1 = picture.GetPixel(i - 1, j - 1);
                    c2 = picture.GetPixel(i, j - 1);
                    c3 = picture.GetPixel(i + 1, j - 1);
                    c4 = picture.GetPixel(i - 1, j);
                    c5 = picture.GetPixel(i, j);
                    c6 = picture.GetPixel(i + 1, j);
                    c7 = picture.GetPixel(i - 1, j + 1);
                    c8 = picture.GetPixel(i, j + 1);
                    c9 = picture.GetPixel(i + 1, j + 1);

                    zr = (c1.R / 9 + c2.R / 9 + c3.R / 9 + c4.R / 9 + c5.R / 9 + c6.R / 9 + c7.R / 9 + c8.R / 9 + c9.R / 9);
                    zg = (c1.G / 9 + c2.G / 9 + c3.G / 9 + c4.G / 9 + c5.G / 9 + c6.G / 9 + c7.G / 9 + c8.G / 9 + c9.G / 9);
                    zb = (c1.B / 9 + c2.B / 9 + c3.B / 9 + c4.B / 9 + c5.B / 9 + c6.B / 9 + c7.B / 9 + c8.B / 9 + c9.B / 9);

                    picture.SetPixel(i, j, Color.FromArgb(zr, zg, zb));

                }
            pictureBox1.Image = picture;
        }

        private void gauseToolStripMenuItem_Click(object sender, EventArgs e)
        {
            int i, j;
            Color z1, z2, z3, z4, z5, z6, z7, z8, z9;
            int z5r, z5g, z5b;
            for (i = 2; i < picture.Width - 2; i++)
                for (j = 2; j < picture.Height - 2; j++)
                {
                    z1 = picture.GetPixel(i - 1, j - 1);
                    z2 = picture.GetPixel(i, j - 1);
                    z3 = picture.GetPixel(i + 1, j - 1);
                    z4 = picture.GetPixel(i - 1, j);
                    z5 = picture.GetPixel(i, j);
                    z6 = picture.GetPixel(i + 1, j);
                    z7 = picture.GetPixel(i - 1, j + 1);
                    z8 = picture.GetPixel(i, j + 1);
                    z9 = picture.GetPixel(i + 1, j + 1);

                    z5r = (z1.R + 2 * z2.R + z3.R + 2 * z4.R + 4 * z5.R + 2 * z6.R + z7.R + 2 * z8.R + z9.R) / 16;
                    z5g = (z1.G + 2 * z2.G + z3.G + 2 * z4.G + 4 * z5.G + 2 * z6.G + z7.G + 2 * z8.G + z9.G) / 16;
                    z5b = (z1.B + 2 * z2.B + z3.B + 2 * z4.B + 4 * z5.B + 2 * z6.B + z7.B + 2 * z8.B + z9.B) / 16;

                    picture.SetPixel(i, j, Color.FromArgb(z5r, z5g, z5b));
                    pictureBox1.Image = picture;
                }
        }

        private void medianToolStripMenuItem_Click(object sender, EventArgs e)
        {
            int i, j;


            Color c1, c2, c3, c4, c5, c6, c7, c8, c9;
            for (i = 2; i <= picture.Width - 2; i++)
                for (j = 2; j < picture.Height - 2; j++)
                {
                    c1 = picture.GetPixel(i - 1, j - 1);
                    c2 = picture.GetPixel(i, j - 1);
                    c3 = picture.GetPixel(i + 1, j - 1);
                    c4 = picture.GetPixel(i - 1, j);
                    c5 = picture.GetPixel(i, j);
                    c6 = picture.GetPixel(i + 1, j);
                    c7 = picture.GetPixel(i - 1, j + 1);
                    c8 = picture.GetPixel(i, j + 1);
                    c9 = picture.GetPixel(i + 1, j + 1);
                    int[] zr = new int[9] { c1.R, c2.R, c3.R, c4.R, c5.R, c6.R, c7.R, c8.R, c9.R };
                    int[] zg = new int[9] { c1.G, c2.G, c3.G, c4.G, c5.G, c6.G, c7.G, c8.G, c9.G };
                    int[] zb = new int[9] { c1.B, c2.B, c3.B, c4.B, c5.B, c6.B, c7.B, c8.B, c9.B };



                    Array.Sort(zr);
                    Array.Sort(zb);
                    Array.Sort(zg);




                    picture.SetPixel(i, j, Color.FromArgb(zr[5], zg[5], zb[5]));

                }
            pictureBox1.Image = picture;
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }
    }
}